/*  $RCSfile: alu16.h,v $ */
/*  $Author: nakane $ */
/*  $Date: 2000/06/30 05:23:51 $ */
/*  $Revision: 1.2 $ */
/*  $State: Exp $ */

declare alu16 {
	input		a<16>, b<16>;
	output		out<16>;
	instrin		and, or, xor, not;
	instrin		add, sub;
	instrin		sll, srl, sra;
	instrin		rol, ror;
	instrin		sgt, slt, seq;
	instrin		sge, sle, sne;	/* not slt, not sgt, not seq	*/

	instr_arg	and(a, b);	/* logical AND			*/
	instr_arg	or(a, b);	/* logical OR			*/
	instr_arg	xor(a, b);	/* logical Exclusive-OR		*/
	instr_arg	not(a, b);	/* logical not			*/

	instr_arg	add(a, b);	/* addition			*/
	instr_arg	sub(a, b);	/* subtraction			*/

	instr_arg	sll(a, b);	/* shift left logical		*/
	instr_arg	srl(a, b);	/* shift right logical		*/
	instr_arg	sra(a, b);	/* shift right arithmetic	*/
	instr_arg	rol(a, b);	/* rotate left			*/
	instr_arg	ror(a, b);	/* rotate right			*/

	instr_arg	sgt(a, b);	/* greater (neither less nor equal) */
	instr_arg	slt(a, b);	/* less (neither greater nor equal) */
	instr_arg	seq(a, b);	/* equal			*/
	instr_arg	sge(a, b);	/* greater or equal		*/
	instr_arg	sle(a, b);	/* less or equal		*/
	instr_arg	sne(a, b);	/* not equal			*/

} 
